KCModule Class Reference

`#include <kcmodule.h>`

Inherits QWidget.

Inherited by KCModuleContainer, and KSettings::PluginPage.

## Public Types

enum | Button { Help =1, Default =2, Apply =16, Reset =4, Cancel =8, Ok =32, SysDefault =64 }

## Signals

void | changed (bool state)
void | quickHelpChanged ()

## Public Member Functions

| KCModule (QWidget *parent=0, const char *name=0, const QStringList &args=QStringList())
| KCModule (KInstance *instance, QWidget *parent=0, const QStringList &args=QStringList())
virtual void | load ()
virtual void | save ()
virtual void | defaults ()
virtual void | sysdefaults ()
virtual QString | quickHelp () const
virtual const KAboutData * | aboutData () const
void | setAboutData (KAboutData *about)
int | buttons () const
QString | rootOnlyMsg () const
bool | useRootOnlyMsg () const
KInstance * | instance () const
const QPtrList < KConfigDialogManager > & | configs () const

## Protected Slots

void | changed ()
void | widgetChanged ()

## Protected Member Functions

KConfigDialogManager * | addConfig (KConfigSkeleton *config, QWidget *widget)
void | setQuickHelp (const QString &help)
void | setButtons (int btn)
void | setRootOnlyMsg (const QString &msg)
void | setUseRootOnlyMsg (bool on)
bool | managedWidgetChangeState () const
void | unmanagedWidgetChangeState (bool)
virtual void | virtual_hook (int id, void *data)

## Detailed Description

The base class for control center modules.

Starting from KDE 2.0, control center modules are realized as shared libraries that are loaded into the control center at runtime.

The module in principle is a simple widget displaying the item to be changed. The module has a very small interface.

All the necessary glue logic and the GUI bells and whistles are provided by the control center and must not concern the module author.

To write a config module, you have to create a library that contains at one factory function like this:

#include <kgenericfactory.h>
typedef KGenericFactory<YourKCModule, QWidget> YourKCModuleFactory;
K_EXPORT_COMPONENT_FACTORY( yourLibName, YourKCModuleFactory("name_of_the_po_file") );

The parameter "name_of_the_po_file" has to correspond with the messages target that you created in your Makefile.am.

See http://developer.kde.org/documentation/other/kcm_howto.html for more detailed documentation.

Author
  Matthias Hoelzer-Kluepfel hoelz.nosp@m.er@k.nosp@m.de.or.nosp@m.g

Definition at line 69 of file kcmodule.h.

## Member Enumeration Documentation

enum KCModule::Button

An enumeration type for the buttons used by this module.

You should only use Help, Default and Apply. The rest is obsolete.

See also
  KCModule::buttons
  KCModule::setButtons

Definition at line 81 of file kcmodule.h.

## Member Function Documentation

const KAboutData * KCModule::aboutData | ( |  | ) | const

virtual

This is generally only called for the KBugReport.

If you override you should have it return a pointer to a constant.

Returns
  the KAboutData for this module

Definition at line 159 of file kcmodule.cpp.

KConfigDialogManager * KCModule::addConfig | ( | KConfigSkeleton * | config,
|  | QWidget * | widget
| ) |  |

protected

Adds a KConfigskeleton `config` to watch the widget `widget`.

This function is useful if you need to handle multiple configuration files.

Since
  3.3

Returns
  a pointer to the KConfigDialogManager in use

Parameters

  config | the KConfigSkeleton to use
  widget | the widget to watch

Definition at line 98 of file kcmodule.cpp.

int KCModule::buttons | ( |  | ) | const

inline

Indicate which buttons will be used.

The return value is a value or'ed together from the Button enumeration type.

See also
  KCModule::setButtons

Definition at line 203 of file kcmodule.h.

void KCModule::changed | ( | bool | state | ) |

signal

Indicate that the state of the modules contents has changed.

This signal is emitted whenever the state of the configuration shown in the module changes. It allows the control center to keep track of unsaved changes.

void KCModule::changed | ( |  | ) |

protected slot

Calling this slot is equivalent to emitting changed(true).

Since
  3.3

Definition at line 190 of file kcmodule.cpp.

const QPtrList< KConfigDialogManager > & KCModule::configs | ( |  | ) | const

Returns
  a list of KConfigDialogManager's in use, if any.

Since
  3.4

Definition at line 212 of file kcmodule.cpp.

void KCModule::defaults | ( |  | ) |

virtual

Sets the configuration to sensible default values.

This method is called when the user clicks the "Default" button. It should set the display to useful values.

If you use KConfigXT, you do not have to reimplement this function since the fetching and settings of default values is done automatically. However, if you reimplement and also are using KConfigXT, remember to call the base function at the very end of your reimplementation.

Reimplemented in KCModuleContainer.

Definition at line 129 of file kcmodule.cpp.

void KCModule::load | ( |  | ) |

virtual

Load the configuration data into the module.

The load method sets the user interface elements of the module to reflect the current settings stored in the configuration files.

This method is invoked whenever the module should read its configuration (most of the times from a config file) and update the user interface. This happens when the user clicks the "Reset" button in the control center, to undo all of his changes and restore the currently valid settings.

If you use KConfigXT, loading is taken care of automatically and you do not need to do it manually. However, if you for some reason reimplement it and also are using KConfigXT, you must call this function otherwise the loading of KConfigXT options will not work.

Reimplemented in KCModuleContainer, and KSettings::PluginPage.

Definition at line 114 of file kcmodule.cpp.

bool KCModule::managedWidgetChangeState | ( |  | ) | const

protected

Returns the changed state of automatically managed widgets in this dialog.

Since
  3.5

Definition at line 141 of file kcmodule.cpp.

QString KCModule::quickHelp | ( |  | ) | const

virtual

Return a quick-help text.

This method is called when the module is docked. The quick-help text should contain a short description of the module and links to the module's help files. You can use QML formatting tags in the text.

Note
  make sure the quick help text gets translated (use i18n()).

Definition at line 206 of file kcmodule.cpp.

void KCModule::quickHelpChanged | ( |  | ) |

signal

Indicate that the module's quickhelp has changed.

Emit this signal whenever the module's quickhelp changes. Modules implemented as tabbed dialogs might want to implement per-tab quickhelp for example.

QString KCModule::rootOnlyMsg | ( |  | ) | const

Get the RootOnly message for this module.

When the module must be run as root, or acts differently for root and a normal user, it is sometimes useful to customize the message that appears at the top of the module when used as a normal user. This function returns this customized message. If none has been set, a default message will be used.

See also
  KCModule::setRootOnlyMsg

Definition at line 175 of file kcmodule.cpp.

void KCModule::save | ( |  | ) |

virtual

Save the configuration data.

The save method stores the config information as shown in the user interface in the config files.

If necessary, this method also updates the running system, e.g. by restarting applications. This normally does not apply for KSettings::Dialog modules where the updating is taken care of by KSettings::Dispatcher.

save is called when the user clicks "Apply" or "Ok".

If you use KConfigXT, saving is taken care off automatically and you do not need to load manually. However, if you for some reason reimplement it and also are using KConfigXT, you must call this function, otherwise the saving of KConfigXT options will not work. Call it at the very end of your reimplementation, to avoid changed() signals getting emitted when you modify widgets.

Reimplemented in KCModuleContainer, and KSettings::PluginPage.

Definition at line 121 of file kcmodule.cpp.

void KCModule::setAboutData | ( | KAboutData * | about | ) |

This sets the KAboutData returned by aboutData()

Since
  3.3

Definition at line 164 of file kcmodule.cpp.

void KCModule::setButtons | ( | int | btn | ) |

inline protected

Sets the buttons to display.

Help: shows a "Help" button. Default: shows a "Use Defaults" button Apply: in kcontrol this will show an "Apply" and "Reset" button in kcmshell this will show an "Ok", "Apply" and "Cancel" button

If Apply is not specified, kcmshell will show a "Close" button.

See also
  KCModule::buttons

Definition at line 309 of file kcmodule.h.

void KCModule::setQuickHelp | ( | const QString & | help | ) |

protected

Sets the quick help.

Since
  3.3

Definition at line 200 of file kcmodule.cpp.

void KCModule::setRootOnlyMsg | ( | const QString & | msg | ) |

protected

Sets the RootOnly message.

This message will be shown at the top of the module of the corresponding desktop file contains the line X-KDE-RootOnly=true. If no message is set, a default one will be used.

See also
  KCModule::rootOnlyMsg

Definition at line 170 of file kcmodule.cpp.

void KCModule::setUseRootOnlyMsg | ( | bool | on | ) |

protected

Change whether or not the RootOnly message should be shown.

Following the value of `on`, the RootOnly message will be shown or not.

See also
  KCModule::useRootOnlyMsg

Definition at line 180 of file kcmodule.cpp.

virtual void KCModule::sysdefaults | ( |  | ) |

inline virtual

Set the configuration to system default values.

This method is called when the user clicks the "System-Default" button. It should set the display to the system default values.

Note
  The default behavior is to call defaults().

Definition at line 166 of file kcmodule.h.

void KCModule::unmanagedWidgetChangeState | ( | bool | changed | ) |

protected

Call this method when your manually managed widgets change state between changed and not changed.

Since
  3.5

Definition at line 153 of file kcmodule.cpp.

bool KCModule::useRootOnlyMsg | ( |  | ) | const

Tell if KControl should show a RootOnly message when run as a normal user.

In some cases, the module don't want a RootOnly message to appear (for example if it has already one). This function tells KControl if a RootOnly message should be shown

See also
  KCModule::setUseRootOnlyMsg

Definition at line 185 of file kcmodule.cpp.

void KCModule::widgetChanged | ( |  | ) |

protected slot

A managed widget was changed, the widget settings and the current settings are compared and a corresponding changed() signal is emitted.

Since
  3.4

Definition at line 136 of file kcmodule.cpp.

The documentation for this class was generated from the following files:

- kcmodule.h
- kcmodule.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys